## ros-humble-depthai 2.22.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4) # For Hunter

# MSVC variable isn't available before 'project' call
# Generalize to Win32 platform for now
if(NOT WIN32)
    set(HUNTER_CONFIGURATION_TYPES "Release" CACHE STRING "Hunter dependencies list of build configurations")
endif()

set(HUNTER_SKIP_PACKAGE_nlohmann_json OFF)
set(BUILD_SHARED_LIBS ON)
# Set type to canonicalize relative paths for user-provided toolchain
set(CMAKE_TOOLCHAIN_FILE "" CACHE FILEPATH "CMake toolchain path")

# Create a custom toolchain to pass certain options to dependencies
set(gen_toolchain "${CMAKE_CURRENT_BINARY_DIR}/generated/toolchain.cmake")

if(EXISTS "${gen_toolchain}" AND ("${_INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE}" STREQUAL "${CMAKE_TOOLCHAIN_FILE}" OR NOT "${CMAKE_TOOLCHAIN_FILE}" STREQUAL ""))
    message(STATUS "Using existing generated toolchain")
else()
    message(STATUS "Generating new toolchain...")
    configure_file(
        "${CMAKE_CURRENT_LIST_DIR}/cmake/toolchain/custom.cmake.in"
        "${gen_toolchain}"
        @ONLY
    )
endif()

set(CMAKE_TOOLCHAIN_FILE "${gen_toolchain}" CACHE STRING "" FORCE)
if(DEFINED _INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE)
    message(STATUS "Using specified toolchain file: ${_INTERNAL_DEPTHAI_ORIGINAL_CMAKE_TOOLCHAIN_FILE} combined into: ${CMAKE_TOOLCHAIN_FILE}")
else()
    message(STATUS "Using toolchain file: ${CMAKE_TOOLCHAIN_FILE}")
endif()

include("cmake/HunterGate.cmake")
HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.23.322.tar.gz"
    SHA1 "cb0ea1f74f4a2c49a807de34885743495fccccbe"
    LOCAL # Local config for dependencies
)

# Move binary dir if windows, to shorten the path
if(WIN32)
    set(HUNTER_BINARY_DIR "${HUNTER_GATE_ROOT}/_bin" CACHE STRING "Hunter binary directory")
endif()

# Create depthai project
project(depthai VERSION "2.22.0" LANGUAGES CXX C)
get_directory_property(has_parent PARENT_DIRECTORY)
if(has_parent)
    set(DEPTHAI_VERSION ${PROJECT_VERSION} PARENT_SCOPE)
endif()

# Set default build type depending on context
set(default_build_type "Release")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git" AND NOT DEFINED ENV{CI})
    set(default_build_type "Debug")
endif()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Set default installation directory
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory" FORCE)
endif()

# Set policies
# CMP0074 dictates that find_package searches environment variable "[packageName]_ROOT" along with regular variable [packageName]_ROOT
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW) # Only introduced in 3.12
endif()

if(POLICY CMP0028)
  cmake_policy(SET CMP0028 NEW)
endif()

# Set to export compile commands for tools like clang-tidy and format
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Add module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/sanitizers")

# Additional options
option(DEPTHAI_CLANG_FORMAT "Enable clang-format target"                  ON)
option(DEPTHAI_CLANG_TIDY "Enable clang-tidy checks during compilation" OFF)
option(DEPTHAI_SANITIZE "Enable Address and Undefined sanitizers for library, examples and tests" OFF)

# Should install depthai core libraries
option(DEPTHAI_INSTALL   "Enable install target for depthai-core targets" ON)

# Debug option
set(DEPTHAI_XLINK_LOCAL "" CACHE STRING "Path to local XLink source to use instead of Hunter")
set(DEPTHAI_SHARED_LOCAL "" CACHE STRING "Path to local depthai-shared source to use instead of submodule")
set(DEPTHAI_BOOTLOADER_SHARED_LOCAL "" CACHE STRING "Path to local depthai-bootloader-shared source to use instead of submodule")

# Enable backward stack printing on crash
if(ANDROID)
    # Backward not supported currently on Android
    set(DEPTHAI_ENABLE_BACKWARD OFF CACHE BOOL "" FORCE)
else()
    option(DEPTHAI_ENABLE_BACKWARD "Enable stacktrace printing on crash using Backward" ON)
    # Additional function information for 'backward' stacktrace
    if(DEPTHAI_ENABLE_BACKWARD)
        set(CMAKE_ENABLE_EXPORTS ON)
    endif()
endif()

# Force Colored output when using Ninja
# Global option - affects all targets
option(FORCE_COLORED_OUTPUT "Always produce ANSI-colored output (GNU/Clang only)" OFF)
if(FORCE_COLORED_OUTPUT)
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
       add_compile_options(-fdiagnostics-color=always)
    elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
       add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Specify exporting all symbols on Windows
if(WIN32 AND BUILD_SHARED_LIBS)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON CACHE BOOL "")
endif()

### Constants
set(PROJECT_EXPORT_GROUP "${PROJECT_NAME}Targets")

## Check if cloned or sources
find_package(Git)
find_package(ament_cmake QUIET)
if(GIT_FOUND)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        RESULT_VARIABLE _git_root_dir_error
        OUTPUT_VARIABLE _git_root_dir
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(DEPTHAI_DOWNLOADED_SOURCES ON)
    if(_git_root_dir_error EQUAL 0 AND "${_git_root_dir}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
        set(DEPTHAI_DOWNLOADED_SOURCES OFF)
    endif()
    message(DEBUG "Git root dir (${_git_root_dir_error}): ${_git_root_dir}")
    message(DEBUG "DepthAI as downloaded sources: ${DEPTHAI_DOWNLOADED_SOURCES}")
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE BUILD_COMMIT
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(
        COMMAND ${GIT_EXECUTABLE} show -s --format=%ci ${BUILD_COMMIT}
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE BUILD_COMMIT_DATETIME
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

### Get and find dependencies

# Include project dependencies
set(DEPTHAI_DEPENDENCY_INCLUDE "" CACHE FILEPATH "Optional cmake file to append to dependency processing, e.g. additional find_package()")
include(depthaiDependencies)

# Add threads preference
set(THREADS_PREFER_PTHREAD_FLAG ON)

# Add depthai-shared, and definitions that it is PC side
include(${CMAKE_CURRENT_LIST_DIR}/shared/depthai-shared.cmake)

# Add depthai-bootloader-shared
include(${CMAKE_CURRENT_LIST_DIR}/shared/depthai-bootloader-shared.cmake)

# Add flags helpers
include(Flags)

### End of dependencies

set(TARGET_CORE_NAME ${PROJECT_NAME}-core)
set(TARGET_CORE_ALIAS core)

# Create core library
add_library(${TARGET_CORE_NAME}
    # depthai-shared sources
    "${DEPTHAI_SHARED_SOURCES}"
    # depthai-bootloader-shared sources
    "${DEPTHAI_BOOTLOADER_SHARED_SOURCES}"
    # sources
    src/device/Device.cpp
    src/device/DeviceBase.cpp
    src/device/DeviceBootloader.cpp
    src/device/DataQueue.cpp
    src/device/CallbackHandler.cpp
    src/device/CalibrationHandler.cpp
    src/device/Version.cpp
    src/pipeline/Pipeline.cpp
    src/pipeline/AssetManager.cpp
    src/pipeline/Node.cpp
    src/pipeline/node/XLinkIn.cpp
    src/pipeline/node/XLinkOut.cpp
    src/pipeline/node/ColorCamera.cpp
    src/pipeline/node/Camera.cpp
    src/pipeline/node/ToF.cpp
    src/pipeline/node/MonoCamera.cpp
    src/pipeline/node/StereoDepth.cpp
    src/pipeline/node/NeuralNetwork.cpp
    src/pipeline/node/ImageManip.cpp
    src/pipeline/node/Warp.cpp
    src/pipeline/node/VideoEncoder.cpp
    src/pipeline/node/DetectionNetwork.cpp
    src/pipeline/node/Script.cpp
    src/pipeline/node/SpatialDetectionNetwork.cpp
    src/pipeline/node/SystemLogger.cpp
    src/pipeline/node/SpatialLocationCalculator.cpp
    src/pipeline/node/AprilTag.cpp
    src/pipeline/node/ObjectTracker.cpp
    src/pipeline/node/IMU.cpp
    src/pipeline/node/EdgeDetector.cpp
    src/pipeline/node/SPIIn.cpp
    src/pipeline/node/FeatureTracker.cpp
    src/pipeline/node/DetectionParser.cpp
    src/pipeline/node/UVC.cpp
    src/pipeline/datatype/Buffer.cpp
    src/pipeline/datatype/ImgFrame.cpp
    src/pipeline/datatype/ImageManipConfig.cpp
    src/pipeline/datatype/CameraControl.cpp
    src/pipeline/datatype/NNData.cpp
    src/pipeline/datatype/ImgDetections.cpp
    src/pipeline/datatype/SpatialImgDetections.cpp
    src/pipeline/datatype/SystemInformation.cpp
    src/pipeline/datatype/StreamMessageParser.cpp
    src/pipeline/datatype/SpatialLocationCalculatorData.cpp
    src/pipeline/datatype/SpatialLocationCalculatorConfig.cpp
    src/pipeline/datatype/AprilTags.cpp
    src/pipeline/datatype/AprilTagConfig.cpp
    src/pipeline/datatype/Tracklets.cpp
    src/pipeline/datatype/IMUData.cpp
    src/pipeline/datatype/StereoDepthConfig.cpp
    src/pipeline/datatype/EdgeDetectorConfig.cpp
    src/pipeline/datatype/TrackedFeatures.cpp
    src/pipeline/datatype/FeatureTrackerConfig.cpp
    src/pipeline/datatype/ToFConfig.cpp
    src/utility/Initialization.cpp
    src/utility/Resources.cpp
    src/utility/Path.cpp
    src/utility/Platform.cpp
    src/utility/Environment.cpp
    src/utility/XLinkGlobalProfilingLogger.cpp
    src/utility/Logging.cpp
    src/xlink/XLinkConnection.cpp
    src/xlink/XLinkStream.cpp
    src/openvino/OpenVINO.cpp
    src/openvino/BlobReader.cpp
    src/bspatch/bspatch.c
)
add_library("${PROJECT_NAME}::${TARGET_CORE_ALIAS}" ALIAS ${TARGET_CORE_NAME})
# Specify that we are building core
target_compile_definitions(${TARGET_CORE_NAME} PUBLIC DEPTHAI_TARGET_CORE)
# Specifies name of generated IMPORTED target (set to alias)
set_target_properties(${TARGET_CORE_NAME} PROPERTIES EXPORT_NAME ${TARGET_CORE_ALIAS})
# Add to list of targets to export and install
list(APPEND targets_to_export ${TARGET_CORE_NAME})

# Add default flags to core
add_default_flags(${TARGET_CORE_NAME})

# And clang-tidy and format
if(DEPTHAI_CLANG_TIDY)
    include(ClangTidy)
    target_clangtidy_setup(${TARGET_CORE_NAME})
endif()

# Set compiler features (c++14), and disables extensions (g++14)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${TARGET_CORE_NAME} PROPERTY CXX_EXTENSIONS OFF)
# Add interface transitive property (C++14)
if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
    target_compile_features(${TARGET_CORE_NAME} INTERFACE cxx_generic_lambdas)
else()
    target_compile_features(${TARGET_CORE_NAME} INTERFACE cxx_std_14)
endif()

# First specify options
option(DEPTHAI_BUILD_TESTS "Build tests" OFF)
option(DEPTHAI_BUILD_EXAMPLES "Build examples - Requires OpenCV library to be installed" OFF)
option(DEPTHAI_BUILD_DOCS "Build documentation - requires doxygen to be installed" OFF)
option(DEPTHAI_OPENCV_SUPPORT "Enable optional OpenCV support" ON)


option(DEPTHAI_BINARIES_RESOURCE_COMPILE "Compile Depthai device side binaries into library" ON)
option(DEPTHAI_USB2_PATCH_ONLY_MODE "Use patch file and full depthai.cmd binary for usb2 mode" ON)
option(DEPTHAI_CMD_PATH "Use local path for depthai.cmd instead of downloading" OFF)
if(DEPTHAI_USB2_PATCH_ONLY_MODE)
    option(DEPTHAI_USB2_PATCH_PATH "Use local path for depthai-usb2-patch.patch instead of downloading" OFF)
else()
    option(DEPTHAI_USB2_CMD_PATH "Use local path for depthai-usb2.cmd instead of downloading" OFF)
endif()

if(DEPTHAI_USB2_PATCH_ONLY_MODE)
    message(STATUS "Compiling ${TARGET_CORE_NAME} resources in PATCH_ONLY mode")
else()
    message(STATUS "Compiling ${TARGET_CORE_NAME} depthai and depthai-usb2 resources")
endif()

# Set constant

=== tests/integration/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

# Add depthai using add_subdirectory
if(NOT TEST_FIND_PACKAGE)
    add_subdirectory("${CMAKE_CURRENT_LIST_DIR}/../../" depthai-core EXCLUDE_FROM_ALL)
endif()

# Create a project with name 'myapp'
set(TARGET_NAME myapp)
project(integration-test)

# Add depthai using find_package
if(TEST_FIND_PACKAGE)
    find_package(depthai CONFIG REQUIRED)
endif()

# Helper function
function(add_runtime_dependencies depending_target dependency)
    if(WIN32)
        if(TARGET ${dependency})
            get_property(imported_configs TARGET ${dependency} PROPERTY IMPORTED_CONFIGURATIONS)
            set(dlls "")
            foreach(cfg ${imported_configs})
                get_property(dll TARGET ${dependency} PROPERTY IMPORTED_LOCATION_${cfg})
                set(dlls ${depthai_dll_libraries} $<$<CONFIG:${cfg}>:${dll}>)
            endforeach()
        endif()
        # TARGET_RUNTIME_DLLS generator expression available since CMake 3.21
        if(CMAKE_VERSION VERSION_LESS "3.21")
            file(GLOB depthai_dll_libraries "${HUNTER_INSTALL_PREFIX}/bin/*.dll")
        else()
            set(depthai_dll_libraries "$<TARGET_RUNTIME_DLLS:${depending_target}>")
        endif()
        # Copy the required dlls
        add_custom_command(TARGET ${depending_target} POST_BUILD COMMAND
            ${CMAKE_COMMAND} -E copy_if_different ${dlls} ${depthai_dll_libraries} $<TARGET_FILE_DIR:${depending_target}>
            COMMAND_EXPAND_LISTS
        )
    endif()
endfunction()

include(CTest)
enable_testing()

# Create target dependant on depthai::core
add_executable(integration-test-core src/main.cpp)
target_link_libraries(integration-test-core PRIVATE depthai::core)
add_runtime_dependencies(integration-test-core usb-1.0)
add_test(integration-test-core integration-test-core)

# Create target dependant on depthai::opencv (if available)
if(TARGET depthai::opencv)
    add_executable(integration-test-opencv src/main.cpp)
    target_link_libraries(integration-test-opencv PRIVATE depthai::opencv)
    add_runtime_dependencies(integration-test-opencv usb-1.0)
    add_test(integration-test-opencv integration-test-opencv)
elseif("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "Win32")
    message(STATUS "Skipping DepthAI OpenCV integration test as its not readily available on Win32 architecture.")
else()
    # Make sure that DepthAI OpenCV support is avaible with x64
    message(FATAL_ERROR "Integration test assumes DepthAI OpenCV support to be available, which seems to be missing.")
endif()

=== debian/changelog ===
ros-humble-depthai (2.22.0-1jammy) jammy; urgency=high

  * UVC Node - Capability to create a pipeline that sends data over UVC (or flash it)
  * ToF Node - Capability to decode ToF data into a depth map
  * New devices: OAK-D-SR (fixes), OAK-D-LR R1, OAK-D SR PoE
  * Reorganized CameraBoardSocket naming
  * Logging improvements
  * Added data throughput profiling, per device and globally
  * Added DEPTHAI_DEVICE_NAME_LIST env var to filter devices by name
  * Bootloader v0.0.26 - Fix for bootloader crash (USB variant)
  * Fix for 4 cameras via ETH
  * Device constructor bugfixes (when taking pipeline, or pipeline with config preapplied, etc...)
  * XLink - Bugfix for wrongly discovered usb path on Windows
  * OV9782 startup stream issue fix
  * #779 - Fixes a parsing issue
  * #469 - Fixes a stuck case if same stream names are used
  * Deprecated RGB/LEFT/RIGHT/... CamerBoardSocket naming. Rely on CAM_[A-H] or setName API
  * Add option to clear crash dump
  * XLink - Added 255.255.255.255 discovery and increased PoE search time
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Wed, 14 Jun 2023 22:00:00 -0000

ros-humble-depthai (2.21.2-1jammy) jammy; urgency=high

  * UPDATE: Use v2.21.2 due to issues this version carries
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Tue, 04 Apr 2023 22:00:00 -0000

ros-humble-depthai (2.21.0-1jammy) jammy; urgency=high

  * Improved x/y accuracy for SpatialLocationCalculator/SpatialDetectionNetwork
  * Support for median and mode, default changed to median in SpatialLocationCalculator/SpatialDetectionNetwork
  * Multi stereo support, ability to run stereo between any 2 calibrated cameras
  * Support for LEFT/RIGHT alignment in stereo node
  * Support to invalidate edge pixels: setNumInvalidateEdgePixels in Stereo Node
  * BrightnessFilter - If the input frame pixel is too dark or too bright, the disparity will be invalidated. Default pixels with value 0 are invalidated in Stereo Node
  * Added disparityToDepthUseSpecTranslation, rectificationUseSpecTranslation, and depthAlignmentUseSpecTranslation options for advanced usage in Stereo Node
  * Fix for RGB-depth alignment when RGB is configured to 12 MP
  * Crash dump support - support to retrieve crash context from the device which can be shared with developers
  * Configurable 3A fps - setIsp3aFps
  * IMU - support to retrieve connected IMU type, and firmware version. Refactored firmware update API
  * BMI270 - enable interrupt mode, timestamps are more consistent now
  * BNO086* - fix for sequence number
  * AR0234 improved AE smoothness, increased max gain to 400x (first 25.6x analog),
  * OV9782 on RGB/CAM-A socket max FPS: 120 (previously was only for OV9282), also improves image quality in very bright light,
  * OV9782/9282 minimum exposure time decreased: 20us -> 10us, helps in very bright light. TODO update tuning to make use of it, currently only possible to use with manual exposure
  * HW sync (trigger mode) enabled for OAK-D-LR, for cameras with matching FPS
  * FW: fix for UART0 / '/dev/ttyS0' init failure in Script node
  * POE power cycle fix - in rare occasions POE devices got stuck after reboot, requiring a manual power cycle
  * [XLink] Increased max number of links from 32 to 64
  * Update FW with performance metrics when DEPTHAI_LEVEL=info is enabled
  * Handle EEPROM boardOptions bit 7 for separate I2C on L/R cameras
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 02 Apr 2023 22:00:00 -0000

ros-humble-depthai (2.20.2-1jammy) jammy; urgency=high

  * Fix for ColorCamera at high resolution while using isp scaling
  * Fix for OV9282 SW sync on devices with OV9782 RGB camera
  * Fix for IMX378/477/577 on sockets other than CAM_A (RGB)
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 30 Jan 2023 23:00:00 -0000

ros-humble-depthai (2.20.1-1jammy) jammy; urgency=high

  * Modified OpenVINO::VERSION_UNIVERSAL API improvements / backward compatibility
  * Bootloader version 0.0.24 (fixes for standalone / flashed usecases)
  * [FW] Status LEDs on some additional devices
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sat, 28 Jan 2023 23:00:00 -0000

ros-humble-depthai (2.19.1-1jammy) jammy; urgency=high

  * Added Device getDeviceName API
  * OAK-FFC 4P (R5M1E5) IR/Dot support
  * Additional Stability bugfixes to go along with 2.19.0 for PoE devices
  * Protected productName field in EEPROM
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Sachin Guruswamy <sachin@luxonis.com>  Sun, 27 Nov 2022 23:00:00 -0000

ros-humble-depthai (2.19.0-1jammy) jammy; urgency=high

  * Stability improvements #616
  * isUserBootloaderSupported API
  * Device.setTimesync(true/false) convenience function to enable or disable subsequent timesyncing
  * Windows improvements with listing BOOTED devices ("udev permissions" issue)
  * Fix OV9282 as MonoCamera on RGB socket (issue was black image)
  * Fix crash under high load (regression with camera events streaming)
  * Fix YOLOv5/7 decoding in case of a single class
  * Fix image size when decimation filter is enabled
  * Fix for certain OV9782 and OV9282 permutations/configs
  * Reset Device timestamp on boot to zero
  * Reworded "No available devices" error message when there are other connected devices connected.
  * Update CI to Node16 compatible actions

 -- Sachin Guruswamy <sachin@luxonis.com>  Mon, 19 Sep 2022 22:00:00 -0000

ros-humble-depthai (2.17.4-1jammy) jammy; urgency=high

  * DEPTHAI_WATCHDOG=0 bugfix (245fb57)
  * V5 Calibration flashing fix
  * FW log level bugfix (#587)
  * Updated DeviceBootloader::Config to retain existing values
  * PoE watchdog issues addressed (74b699c)


=== debian/control ===
Source: ros-humble-depthai
Section: misc
Priority: optional
Maintainer: Sachin Guruswamy <sachin@luxonis.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, libusb-1.0-0-dev, nlohmann-json3-dev, ros-humble-ament-cmake, ros-humble-ros-environment, ros-humble-ros-workspace
Homepage: https://www.luxonis.com/
Standards-Version: 3.9.2

Package: ros-humble-depthai
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, libusb-1.0-0-dev, nlohmann-json3-dev, ros-humble-ros-workspace
Description: DepthAI core is a C++ library which comes with firmware and an API to interact with OAK Platform

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-depthai//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-depthai 2.26.0

=== debian/changelog ===
ros-humble-depthai (2.26.0-1bookworm) bookworm; urgency=high

  * PointCloud node along with the PointCloudData message
  * On device pointcloud generation
  * Native conversion to PCL message type - similar to getCvFrame()
  * Support for the OAK Thermal
  * New setManualFocusRaw() API with more granularity for setting manual focus position
  * New getStereoPairs() and getAvailableStereoPairs() API to allow more device agnostic programming
  * Add the intensity output to the ToF node
  * Add the crop sensor configs in getConnectedCameraFeatures() now contain how each of the resolutions is cropped from the native sensor resolution
  * Added DeviceBootloader::getFlashedVersion to retrieve the bootloader version that is flashed on device.
  * ImageAlign node
  * it can align depth to any other sensor on the device - works for ToF too.
  * it can align two sensors with each other using intrinsics only, useful for thermal-rgb alignment
  * Cast node
  * Cast NNData message to ImgFrame
  * Useful in case apps need to use outputs from NeuralNetwork node to be fed into nodes that only accept ImgFrame
  * Full ToF support
  * Running live at 30 FPS
  * Measuring range of 20cm - 6m
  * < 1% error across the range
  * Support for ToF in spatial nodes
  * Add an option to limit bandwidth over XLink setXLinkRateLimit(int maxRateBytesPerSecond, int burstSize, int delayUs)
  * Bug fix for v2.24.0 regression with flashing the bootloader link
  * Bug fix in message groups for large resolution frames when going through XLinkOut node
  * Bug fix to apply AE limit during AF lens movement (before the fix, the AE limit wasn't applied during active AF movements)
  * Bug fix for grayscale VideoEncoder node with 2 inputs of different sizes
  * Fix timings for IMX214 4K resolution, which were slightly off
  * Fixed fsync on OAK-D-SR.
  * Fixed boot issue on OAK-D-SR-POE and OAK-T.
  * Fixed compilation in same cases, because of problems with jsoncpp. (#980)
  * Improved PoE stability on reboots - eliminate the case where powercycle of the device was sometimes needed
  * Improved runtime stability of heavy pipelines by increasing priority of the cameras in the NoC
  * Improved ImageManip stability
  * Improved XLink communication to be able to detect memory corruption and avoid it
  * Fix a bug where stereo rectification was inaccurate when the calibration data didn't contain direct link between the two inputs
  * Relevant for custom setups on FFC devices
  * Improve numerical stability of the rectification algorithm
  * Improves stereo quality on wide FOV sensors
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Adam Serafin <adam.serafin@luxonis.com>  Sun, 26 May 2024 16:00:00 -0000

ros-humble-depthai (2.24.0-1bookworm) bookworm; urgency=high

  * New nodes and messages:
  * Sync node - syncs multiple inputs based on the timestamp, outputs a message group message
  * Demux node - demultiplexes message group in multiple messages
  * Message group message - a new message that can contain a map of arbitrary depthai messages, it's the output of the sync node and input to the demux node
  * Encoded frame message - a new message specialized for encoded frames
  * New output for the VideoEncoder node (out) for the encoded frame message
  * Automatic crash dump retrieval for firmware crashes
  * Added setIrFloodLightIntensity and setIrLaserDotProjectorIntensity methods for setting the intensity normalized between 0 and 1
  * Added getConnectionInterfaces method to retrieve the list of available interfaces on a device
  * Added an option to cap maximum time for exposure when using auto exposure with setAutoExposureLimit
  * Initial integration for IMX283 and IMX462
  * Improve time-syncing between the host and device to achieve sub 300 us offset
  * Improved max FPS and image quality under low light for OV9282 and OV9782 #926 ,new ranges per resolution of:
  * THE_800_P: 1.687 .. 129.6 fps
  * THE_720_P: 1.687 .. 143.1 fps
  * THE_400_P: 1.687 .. 255.7 fps
  * Avoid overflow for XLink profiling #933
  * Improve XLink stability when using multiple devices luxonis/XLink#73
  * Fix a rare bug where the device would hand in the constructor #922
  * Fix a bug where XLinkIn didn't work correctly for very small and very large buffers
  * Fix a bug for running multiple stereo nodes with a shared input
  * On multi-input NeuralNetworks set the output NNData to the newest input timestamp (previously undefined)
  * Add NOC DDR usage reporting on DEPTHAI_LEVEL=info
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Adam Serafin <adam.serafin@luxonis.com>  Thu, 01 Feb 2024 16:00:00 -0000

ros-humble-depthai (2.23.0-1bookworm) bookworm; urgency=high

  * ImageManip - configurable interpolation type
  * Script - added missing bindings for reading device releated data (on device calibration, etc...)
  * Added Device::getDeviceName and Device::getProductName that target a user name and a "SKU" name
  * Timesync - improved synchronization with tweaks to XLink
  * Calibration - added housingExtrinsics
  * Fix CAM_D enumeration on OAK-FFC-4P R7
  * BMI270 IMU - fix latency when slow reading
  * Device related logging
  * OAK-D-SR-POE - new revision bugfixes
  * Fix 4 cameras crash on PoE due to memory allocation
  * Fixed incorrect warp in issue #882
  * XLink - updated number of devices to 64
  * ToF - median filter and Z map support (still not the final decoding pipeline)
  * hasAutofocus value fixed and introduced hasAutofocusIC
  * Added timestamps and sequence numbers to all Message types
  * Added DEPTHAI_ENABLE_LIBUSB for potentially disabling USB protocol (to not require libusb library)
  * OV9782 and AR0234 improvements:
  * OV9782 FPS improvements
  * AR0234 max exposure time bump to 33ms and improved FSync INPUT mode
  * Contributors: Alex Bougdan, Szabolcs Gergely, Martin Peterlin

 -- Adam Serafin <adam.serafin@luxonis.com>  Mon, 13 Nov 2023 16:00:00 -0000



## ros-humble-depthai 2.28.0

=== debian/changelog ===
ros-humble-depthai (2.28.0-1bookworm) bookworm; urgency=high

  Features
  * Changed the automatic crashdump collection to always on unless DEPTHAI_DISABLE_CRASHDUMP_COLLECTION is set.
  * Added DEPTHAI_ENABLE_ANALYTICS_COLLECTION environment varialbe - when set, analytic data (pipeline schema) is sent to Luxonis which will be used to further improve the library.
  * Undistort both outputs of ToF by default.
  * Improved 3A syncing on OAK-D-LR
  * Added support for YoloV10
  * Bug fixes
  * Fix Camera node to correctly allocate resources for undistortion
  * Fix StereoDepth node when decimation filter and depth alignment are used
  * Fix host timestamps of thermal frames to be synced
  * Misc
  * Updated XLink to support clangd and shared libraries on Windows:
  * luxonis/XLink#81
  * luxonis/XLink#84
  * Remove a custom assert to always produce a crash dump to improve the UX with the automatic crashdump collection
  * Increased watchdog priority on device side to improve stability during high load

 -- Adam Serafin <adam.serafin@luxonis.com>  Tue, 20 Aug 2024 16:00:00 -0000

ros-humble-depthai (2.26.1-1bookworm) bookworm; urgency=high

  * Fix building shared libs (ROS only)

 -- Adam Serafin <adam.serafin@luxonis.com>  Tue, 11 Jun 2024 16:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ros-humble-depthai
 Section: misc
 Priority: optional
-Maintainer: Sachin Guruswamy <sachin@luxonis.com>
+Maintainer: Adam Serafin <adam.serafin@luxonis.com>
 Build-Depends: debhelper (>= 9.0.0), libopencv-dev, libusb-1.0-0-dev, nlohmann-json3-dev, ros-humble-ament-cmake, ros-humble-ros-environment, ros-humble-ros-workspace
 Homepage: https://www.luxonis.com/
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-depthai//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-depthai//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-depthai//opt/ros/humble/opt/depthai/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
